/*
 * protocol initialization calls
 *
 * Warning: this file is generated from graph.comp and is overwritten
 * every time 'make compose' is run
 */

#include "upi.h"
#include "x_util.h"
#include "compose.h"
#include "protocols.h"


XObj		protl_tab[6+1];
static XObj	argv[6];


void
build_pgraph_dev()
{
}


void
build_pgraph()
{

  /*
   *  building protocol ETH
   */
  protl_tab[0] = xCreateProtl(eth_init, "eth", "",
#ifdef XK_DEBUG
			&traceethp,
#else
			0,
#endif
				0, argv);
  if ( protl_tab[0] == ERR_XOBJ ) {
      Kabort("Could not create eth protocol");
  }


  /*
   *  building protocol ARP
   */
  argv[0] = protl_tab[0];
  protl_tab[1] = xCreateProtl(arp_init, "arp", "foo",
#ifdef XK_DEBUG
			&traceproxy,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[1] == ERR_XOBJ ) {
      Kabort("Could not create arp protocol");
  }


  /*
   *  building protocol IP
   */
  argv[0] = protl_tab[0];
  argv[1] = protl_tab[1];
  protl_tab[2] = xCreateProtl(ip_init, "ip", "",
#ifdef XK_DEBUG
			&traceipp,
#else
			0,
#endif
				2, argv);
  if ( protl_tab[2] == ERR_XOBJ ) {
      Kabort("Could not create ip protocol");
  }


  /*
   *  building protocol PROT3
   */
  argv[0] = protl_tab[0];
  protl_tab[5] = xCreateProtl(prot3_init, "prot3", "",
#ifdef XK_DEBUG
			&traceprot3p,
#else
			0,
#endif
				1, argv);
  if ( protl_tab[5] == ERR_XOBJ ) {
      Kabort("Could not create prot3 protocol");
  }


  /*
   *  building protocol PROT2
   */
  argv[0] = protl_tab[0];
  argv[1] = protl_tab[5];
  protl_tab[4] = xCreateProtl(prot2_init, "prot2", "",
#ifdef XK_DEBUG
			&traceprot2p,
#else
			0,
#endif
				2, argv);
  if ( protl_tab[4] == ERR_XOBJ ) {
      Kabort("Could not create prot2 protocol");
  }


  /*
   *  building protocol PROT1
   */
  argv[0] = protl_tab[2];
  argv[1] = protl_tab[4];
  argv[2] = protl_tab[1];
  protl_tab[3] = xCreateProtl(prot1_init, "prot1", "",
#ifdef XK_DEBUG
			&traceprot1p,
#else
			0,
#endif
				3, argv);
  if ( protl_tab[3] == ERR_XOBJ ) {
      Kabort("Could not create prot1 protocol");
  }

}
