/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.2
 * 
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: sem.h,v $
 *
 * HISTORY
 * $Log: sem.h,v $
 * Revision 1.2  1994/06/11 00:02:19  menze
 * Added copyright notice
 *
 * Revision 1.1  1994/05/15  00:24:28  davidm
 * Initial revision
 *
 */
#ifndef sem_h
#define sem_h

#include "scout_queue.h"

typedef struct {
    int		count;
    Scout_Queue	waitingQ;
} Semaphore;

extern void	semInit (Semaphore *s, u_int initialVal);
extern void	semWait (Semaphore *s);
extern void	semSignal (Semaphore *s);

#endif /* sem_h */
